export class BranchMergeIndex {
    constructor(db) {
        Object.defineProperty(this, "db", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: db
        });
    }
    async insertBranchMerge(record) {
        const id = `${record.source_branch}:${record.source_clock}:${record.target_branch}:${record.target_clock}`;
        await this.db.set("$branch_merges", { id, ...record });
    }
}
Object.defineProperty(BranchMergeIndex, "schema", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: {
        $branch_merges: {
            id: "primary",
            source_branch: "integer",
            source_message_id: "string",
            source_clock: "integer",
            target_branch: "integer",
            target_message_id: "string",
            target_clock: "integer",
        },
    }
});
