import type { Signature, Message } from "@canvas-js/interfaces";
export type MessageSource = {
    type: "pubsub" | "push" | "sync";
    peer: string;
};
export type MessageContext = {
    source?: MessageSource;
    branch?: number;
};
export declare class SignedMessage<Payload = unknown> {
    readonly signature: Signature;
    readonly message: Message<Payload>;
    readonly value: Uint8Array;
    static decode<Payload = unknown>(value: Uint8Array, context?: MessageContext): SignedMessage<Payload>;
    static encode<Payload>(signature: Signature, message: Message<Payload>, context?: MessageContext): SignedMessage<Payload>;
    readonly id: string;
    readonly key: Uint8Array;
    readonly source?: MessageSource;
    branch?: number;
    private constructor();
}
