export class MissingParentError extends Error {
    constructor(parent, id) {
        super(`missing parent ${parent} of ${id}`);
        Object.defineProperty(this, "parent", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: parent
        });
        Object.defineProperty(this, "id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: id
        });
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: MissingParentError.name
        });
    }
}
Object.defineProperty(MissingParentError, "name", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: "MISSING_PARENT"
});
export class MessageNotFoundError extends Error {
    constructor(id) {
        super(`message ${id} not found`);
        Object.defineProperty(this, "id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: id
        });
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: MessageNotFoundError.name
        });
    }
}
Object.defineProperty(MessageNotFoundError, "name", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: "MESSAGE_NOT_FOUND"
});
export class ConflictError extends Error {
    constructor(source, target) {
        super(`conflicting values for key`);
        Object.defineProperty(this, "source", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: source
        });
        Object.defineProperty(this, "target", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: target
        });
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: ConflictError.name
        });
    }
}
Object.defineProperty(ConflictError, "name", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: "CONFLICT"
});
export class AbortError extends Error {
    constructor() {
        super("sync aborted by server");
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: AbortError.name
        });
    }
}
Object.defineProperty(AbortError, "name", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: "ABORT"
});
